{% extends "customers/customer_detail.html" %}
{% load active_tag %}
{% load i18n %}
{% load price_tag %}
{% block title %}Servicios Contratados por {{ customer.name }}{% endblock %}


{% block page %}
{%if can_show_detail %}
	<!-- begin breadcrumb -->
	<ol class="breadcrumb float-xl-right">
		<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
		<li class="breadcrumb-item"><a href="{% url 'customer-list' %}">Clientes</a></li>
    <li class="breadcrumb-item"><a href="{% url 'customer-detail' pk=customer.pk %}">{{ customer.rut }}</a></li>
    <li class="breadcrumb-item active">Servicios Contratados</li>
	</ol>
	<!-- end breadcrumb -->

	<!-- begin page-header -->
	<h1 class="page-header">{{ customer.name }}<small></small></h1>
	<!-- end page-header -->

	<ul class="nav nav-pills mb-2">
    <li class="nav-item {% add_active request 'customer-detail' %}">
      <a href="{% url 'customer-detail' customer.pk %}"class="nav-link">
        <span class="d-sm-none">General</span>
        <span class="d-sm-block d-none">General</span>
      </a>
    </li>
    <li class="nav-item">
        <a href="#" class="nav-link active">
            <span class="d-sm-none">Servicios</span>
            <span class="d-sm-block d-none">Servicios</span>
        </a>
    </li>
		<li class="nav-item {% add_active request 'customer-payment-methods' %}">
			<a href="{% url 'customer-payment-methods' customer.pk %}" class="nav-link">
				<span class="d-sm-none">Métodos de Pago</span>
				<span class="d-sm-block d-none">Métodos de Pago</span>
			</a>
		</li>
		<li class="nav-item {% add_active request 'invoice-list' %}">
			<a href="{% url 'invoice-list' customer.pk %}" class="nav-link">
				<span class="d-sm-none">Estado de Cuenta</span>
				<span class="d-sm-block d-none">Estado de Cuenta</span>
			</a>
		</li>
        <li class="nav-item {% add_active request 'invoice-list' %}">
			<a href="{% url 'customer-configuration' customer.pk %}" class="nav-link">
				<span class="d-sm-none">Configuración</span>
				<span class="d-sm-block d-none">Configuración</span>
			</a>
		</li>
    <li class="nav-item {% add_active request 'invoice-list' %}">
			<a href="{% url 'customer-widget' customer.pk %}" class="nav-link">
				<span class="d-sm-none">Widget</span>
				<span class="d-sm-block d-none">Widget</span>
			</a>
		</li>	
	</ul>

	  
	<!-- begin row -->
	<div class="row">
		<!-- begin col-12 -->
		<div class="col-xl-12 ui-sortable">
			<!-- begin panel -->
			<div class="panel panel-inverse" data-sortable-id="ui-general-1">
				<!-- begin panel-heading -->
				<div class="panel-heading ui-sortable-handle">
					<h4 class="panel-title">Servicios Contratados</h4>
					<div class="panel-heading-btn">
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
					</div>
				</div>
				<!-- end panel-heading -->
				<!-- begin panel-body -->
				<div class="panel-body">
          {% if perms.customers.add_service %}
            <a class="btn btn-success btn-sm pull-right ml-1" href="{% url 'service-create' customer.pk %}">
              Nuevo Servicio
            </a>
            <button id="changeOperator" class="btn btn-warning btn-sm pull-right ml-1" href="" data-toggle="modal" data-target="#operatorModal" disabled>
              Cambiar Operador
            </button>
          {% endif %}
          <!-- begin modal -->
          <div class="modal fade" id="operatorModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div id="modalHeader" class="modal-header">
                  <h5 class="modal-title" id="operatorModalLabel">Cambio masivo</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div  class="modal-body">
                  <div id="modalBody" class="form-group">
                    <label for="exampleFormControlSelect1">Operador</label>
                      <select id="operatorSelect" class="form-control" id="exampleFormControlSelect1">
                        {% for operator in operators %}
                          <option value="{{ operator.id }}">{{ operator.name }}</option>
                        {% endfor %}
                      </select>
                  </div>
                  <div id="modalBodyAlert" style="text-align:center; display: none;"><h4 class="text-success">Operador Actualizado!</h4></div>
                </div>
                <div id="modalFooter" class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                  <button id="changeOperators" type="button" class="btn btn-primary" >Cambiar</button>
                </div>
              </div>
            </div>
          </div>
          <!-- end modal -->
          <div id="extra">
            <table class="table table-striped">
              <thead>
                <tr>
                  <th><input id="checkMaster" type="checkbox" onclick="checkAll()"></th>
                  <th>Número de Servicio</th>
                  <th>{% trans 'plan' as tr_plan %}{{ tr_plan|capfirst }}</th>
                  <th>Dirección</th>
                  <th>Precio</th>
                  <th>Tipo documento</th>
                  <th>Estado</th>
                  <th>Red</th>
                  <th>Nodo</th>
                  <th>Operador</th>
                </tr>
              </thead>
              <tbody>
                {% for service in services %}
                  <tr id="service_{{ service.number }}">
                    <th><input class="rowCheckbox" type="checkbox" name="" value=""></th>
                    <th scope="row"><a href="{% url 'service-detail' slug=service.pk %}">{{ service.number }}</a></th>
                    <td>{{ service.plan.name }}</td>
                    <td>{{ service.best_address }}</td>
                    <td>${{ service.monthly_price|price_tag }}</td>
                    <td>{{ service.get_document_type_display|capfirst }}</td>
                    <td><span class="label label-{{ service.get_status_class }}">{{ service.get_status_display|capfirst }}</td>
                    <td><span class="label label-{{ service.network_status.0 }}">{{ service.network_status.1|capfirst }}</td>
                    <td>{{ service.node_sentinel.alias |default:"Desconocido"}}</td>
                    <td>
                      <span class="operator" style="float:left;">{{ service.operator }}</span>
                      <span class="operatorSelector" style="float:left; display: none;"><select></select></span>
                      <span style="float:right;">
                        <a href="#" onclick="selectOperator(this); return false;">
                          <i class="fa fa-pen"></i>
                        </a>
                      </span>
                    </td>
                  </tr>
                {% endfor %}
              </tbody>
            </table>
          </div>
          <input type="hidden" id="operatorsList" name="variable" value="{{ operators_json }}">
				</div>
				<!-- end panel-body -->
			</div>
			<!-- end panel -->
		</div>
		<!-- end col-12 -->
	</div>
	<!-- end row -->

	<!-- begin scroll to top btn -->
	<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
	<!-- end scroll to top btn -->
	{%else%}
	<div class="alert alert-success"  style="background-color: rgb(245, 156, 26); text-align: center;" role="alert">
		<h4 class="alert-heading">No encontrado</h4>
		<hr>
		<h5 class="mb-0">Cambie de operador o vuelva al listado de clientes.</h5>
	</div>
	{%endif%}
{% endblock %}

{% block pageleveljs %}

  <script type="text/javascript">
    var btn = document.getElementById('changeOperator');
    var checkmaster = document.getElementById('checkMaster');

    $('#changeOperator').attr('disabled','disabled');
    checkButton();
    checkEveryOne()

    function checkButton(){
      if(checkmaster.checked==true){
        $('#changeOperator').removeAttr('disabled');
      } else{
        $('#changeOperator').attr('disabled','disabled');
      }
    }

    
    $('.rowCheckbox').change(
      function(){
          checkEveryOne();
    });

    function checkEveryOne() {
      var rowCheckboxs = document.getElementsByClassName('rowCheckbox');
      var count = 0;
      for(var i=0; i < rowCheckboxs.length; i++) {
        if (rowCheckboxs[i].checked == true){
          count++;
        }
      }
      if (count != 0){
        $('#changeOperator').removeAttr('disabled');
      } else{
        $('#changeOperator').attr('disabled','disabled');
        checkmaster.checked = false;
      }
    }

    function checkAll() {
      checkButton();
      
      var rowCheckboxs = document.getElementsByClassName('rowCheckbox');
      for(var i=0; i < rowCheckboxs.length; i++) {
        rowCheckboxs[i].checked = checkmaster.checked;
      }
    }

    function selectOperator(el){
      var myVar = document.getElementById("operatorsList").value;
      var json = JSON.parse(myVar); 
      var td = el.parentElement.parentElement;
      var selectList = document.createElement("select");
      //selectList.class = "form-control oneOperatorSelect";
      selectList.classList.add("form-control");
      selectList.classList.add("oneOperatorSelect");
      var i;
      for (i = 0; i < json.data.length; i++) {
        var option = document.createElement("option");
        option.text = json.data[i].name;
        option.value = json.data[i].id;
        if(option.text == td.children[0].innerHTML){
          option.selected = true;
        }
        selectList.add(option); 
      } 
      td.children[0].style.display = "none";
      td.children[1].style.display = "block";

      var span_node = td.children[1];

      span_node.replaceChild(selectList, span_node.children[0]);

      el.parentElement.innerHTML = '<a style="line-height:35px;" href="#" onclick="changeOperator(this); return false;"><i style="padding-right:1rem;" class="fa fa-check-square text-success"></i></a><a style="line-height:35px;" href="#" onclick="changeOperator(this); return false;"><i class="fa fa-window-close text-danger"></i></a>';
      
    }
    function changeOperator(el){
      child = el.children[0];
      if(child.classList.contains('fa-window-close')){
        el.parentElement.parentElement.children[0].style.display = "block";
        el.parentElement.parentElement.children[1].style.display = "none";
        el.parentElement.innerHTML = '<a href="#" onclick="selectOperator(this); return false;"><i class="fa fa-pen"></i></a>';
        
      }else{
        var tr = el.parentElement.parentElement.parentElement;
        var service = tr.children[1].innerText;
        var operator = el.parentElement.parentElement.children[1].children[0].value;
        changeOperatorAjax(operator, service);
        el.parentElement.innerHTML = '<span class="text-success">Operador Actualizado!</span>';
        
        setTimeout(function() {
          setPen();
        }, 1500);
        
        function setPen(){
          el_name = "service_" + service;
          el = document.getElementById(el_name);
          el.children[9].children[2].innerHTML = '<a href="#" onclick="selectOperator(this); return false;"><i class="fa fa-pen"></i></a>';
        }

        
      }
    }

    $('#changeOperators').click(function(){
      var services = [];

      var rowCheckboxs = document.getElementsByClassName('rowCheckbox');

      var operator = document.getElementById('operatorSelect').value;
      var count = 0;
      for(var i=0; i < rowCheckboxs.length; i++) {
        if(rowCheckboxs[i].checked==true){
          services[count] = rowCheckboxs[i].parentElement.parentElement.children[1].innerText;
          count++;        
        }
      }
      
      $.get('/operators_ajax/', {services: JSON.stringify(services), operator: operator}, function(json_response) {;
        document.addEventListener("click",handler,true);

        function handler(e){
            e.stopPropagation();
            e.preventDefault();
        }

        document.getElementById('modalBody').style.display ='none';
        document.getElementById('modalBodyAlert').style.display ='block';
        document.getElementById('modalHeader').style.visibility ='hidden';
        document.getElementById('modalFooter').style.visibility ='hidden';
        json = json_response.data;
        
        Object.keys(json).forEach(function(key){
          el_name = "service_" + key;
          el = document.getElementById(el_name);
          el.children[9].children[0].innerText = json[key];
        });
        setTimeout(closeModal, 1000);
        function closeModal(){
          $('#operatorModal').modal('hide');
          setTimeout(populateModal, 1000);
        }
        
        function populateModal(){
          document.getElementById('modalBody').style.display ='block';
          document.getElementById('modalBodyAlert').style.display ='none';
          document.getElementById('modalHeader').style.visibility ='visible';
          document.getElementById('modalFooter').style.visibility ='visible';
          document.removeEventListener('click', handler, true)
        }
        
        

      });
    });

    function changeOperatorAjax(operator, service){
      $.get('/operator_ajax/', {service: service, operator: operator}, function(json_response) {
        el_name = "service_" + service;
        el = document.getElementById(el_name);
        el.children[9].children[1].style.display = 'none';
        el.children[9].children[0].innerText = json_response.data;
        el.children[9].children[0].style.display = 'block';
      });
    }


  </script>

{% endblock %}




